package thermo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: JThermo</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: www.LancOS.com</p>
 * @author Claudio Lanconelli
 * @version 1.0
 */

public class JThermoFrame extends JFrame {
    JPanel contentPane;
    JToolBar jToolBar = new JToolBar();
    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image3;
    BorderLayout borderLayout1 = new BorderLayout();
    JButton jButton_Update = new JButton();
	JThermoGUI jthermo = new JThermoGUI();

	Ds1621 thermo = new Ds1621();       //Instanzia la classe del sensore di temperatura

    //Construct the frame
    public JThermoFrame() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
		ThermoInit(1, 1, false);	//DS1621 sensor
	//	ThermoInit(1, 1, true);		//DS1631 sensor
    }
    //Component initialization
    private void jbInit() throws Exception  {
        image1 = new ImageIcon(thermo.JThermoFrame.class.getResource("openFile.gif"));
        image2 = new ImageIcon(thermo.JThermoFrame.class.getResource("closeFile.gif"));
        image3 = new ImageIcon(thermo.JThermoFrame.class.getResource("help.gif"));
        //setIconImage(Toolkit.getDefaultToolkit().createImage(JThermoFrame.class.getResource("[Your Icon]")));
        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(borderLayout1);
        this.getContentPane().setBackground(Color.white);
        this.setResizable(false);
        this.setSize(new Dimension(150, 341));
        this.setTitle("JThermo");
        jButton_Update.setText("Update");
        jButton_Update.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton_Update_actionPerformed(e);
            }
        });
        contentPane.setMinimumSize(new Dimension(144, 315));
        contentPane.setPreferredSize(new Dimension(144, 315));
        jToolBar.add(jButton_Update, null);
        contentPane.add(jToolBar, BorderLayout.NORTH);
		contentPane.add(jthermo, BorderLayout.CENTER);
    }
    //File | Exit action performed
	public void jMenuFileExit_actionPerformed(ActionEvent e)
	{
		ThermoClose();
		System.exit(0);
	}
    //Help | About action performed
    public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
        JThermoFrame_AboutBox dlg = new JThermoFrame_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.show();
    }
    //Overridden so we can exit when window is closed
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

	private void ThermoInit(int selector, int port, boolean mode)
	{
		/* inizializzazione da fare solo all'inizio */
		thermo.setOneShotMode(true);    //Impostazione della modalita` di funzionamento (una lettura alla volta)
		thermo.setDS1631Mode(mode);
		thermo.Open(port);      //Apertura della porta seriale COM (1 o 2 o 3 o 4)

		thermo.setAddress(selector);  //(8) Impostazione indirizzo del sensore, in questo caso e` 8
		thermo.Init();              //Inizializzazione del sensore
	}

	private void ThermoClose()
	{
		//Codice di chiusura da fare una sola volta alla fine
		thermo.Close();     //Chiusura della seriale
	}

	private int ThermoRead(int values[])
	{
		int rv = 0;

		/* per leggere la temperatura fare in sequenza StartConversion, WaitConversion e Readtemperature */
		rv = thermo.StartConversion();      //Lancia la conversione
		if (rv == 0)
			rv = thermo.WaitConversion();   //Attende la fine della conversione

		if (rv == 0)
			rv = thermo.ReadTemperature(values, 0);  //Legge la temperatura in formato binario, per convertirlo in numero reale dividerlo per 256

		return rv;
	}

	void jButton_Update_actionPerformed(ActionEvent e)
	{
		int values[] = new int[8];
	//	int comport = 1;
		int rv;

		values[0] = 0;
		rv = ThermoRead(values);
		jthermo.setErrore(rv);
		if (rv == 0)
		{
		//	System.out.print("Temp: " + Integer.toHexString(values[0]) + "\r\n");
			float temp = (float)values[0] / (float)256;
			jthermo.setLivello(temp);
		}
		else
		{
			jthermo.setLivello(0);
		}
	}

}